glibmm 2.29.12

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions

# Gio::ActionGroup Class Reference

ActionGroup - a group of actions. More...

`#include <giomm/actiongroup.h>`

Inheritance diagram for Gio::ActionGroup:
[legend]

List of all members.

## Public Member Functions
virtual | ~ActionGroup ()
GActionGroup* | gobj ()
| Provides access to the underlying C GObject.
const GActionGroup* | gobj () const
| Provides access to the underlying C GObject.
bool | has_action (const Glib::ustring& action_name) const
| Checks if the named action exists within action_group.
std::vector< Glib::ustring > | list_actions () const
| Lists the actions contained within action_group.
bool | get_action_enabled (const Glib::ustring& action_name) const
| Checks if the named action within action_group is currently enabled.
void | change_action_state (const Glib::ustring& action_name, const Glib::VariantBase&value)
| Request for the state of the named action within action_group to be changed to value.
void | activate_action (const Glib::ustring& action_name, const Glib::VariantBase& parameter)
| Activate the named action within action_group.
void | action_added (const Glib::ustring& action_name)
| Emits the ActionGroup::action-added signal on action_group.
void | action_removed (const Glib::ustring& action_name)
| Emits the ActionGroup::action-removed signal on action_group.
void | action_enabled_changed (const Glib::ustring& action_name, bool enabled)
| Emits the ActionGroup::action-enabled-changed signal on action_group.
void | action_state_changed (const Glib::ustring& action_name, const Glib::VariantBase& state)
| Emits the ActionGroup::action-state-changed signal on action_group.
Glib::SignalProxy1< void, const Glib::ustring& > | signal_action_added ()
Glib::SignalProxy2< void, const Glib::ustring&, bool > | signal_action_enabled_changed ()
Glib::SignalProxy1< void, const Glib::ustring& > | signal_action_removed ()
Glib::SignalProxy2< void, const Glib::ustring&, const Glib::VariantBase& > | signal_action_state_changed ()
## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
## Protected Member Functions
virtual void | on_action_added (const Glib::ustring& action_name)
virtual void | on_action_enabled_changed (const Glib::ustring& action_name, bool enabled)
virtual void | on_action_removed (const Glib::ustring& action_name)
virtual void | on_action_state_changed (const Glib::ustring& action_name, const Glib::VariantBase&value)
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::ActionGroup > | wrap (GActionGroup* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

ActionGroup - a group of actions.

ActionGroup represents a group of actions.

Each action in the group has a unique name (which is a string). All method calls, except list_actions() take the name of an action as an argument.

The GActionGroup API is meant to be the 'public' API to the action group. The calls here are exactly the interaction that 'external forces' (eg: UI, incoming D-Bus messages, etc.) are supposed to have with actions. 'Internal' APIs (ie: ones meant only to be accessed by the action group implementation) are found on subclasses. This is why you will find -- for example -- get_action_enabled() but not an equivalent `set()` call.

Signals are emitted on the action group in response to state changes on individual actions.

## Constructor & Destructor Documentation

virtual Gio::ActionGroup::~ActionGroup | ( |  | ) | `[virtual]`

## Member Function Documentation

void Gio::ActionGroup::action_added | ( | const Glib::ustring& | action_name | ) |

Emits the ActionGroup::action-added signal on action_group.

This function should only be called by ActionGroup implementations.

Since glibmm 2.28:

Parameters:

  action_name | The name of an action in the group.

void Gio::ActionGroup::action_enabled_changed | ( | const Glib::ustring& | action_name,
|  | bool | enabled
| ) |  |

Emits the ActionGroup::action-enabled-changed signal on action_group.

This function should only be called by ActionGroup implementations.

Since glibmm 2.28:

Parameters:

  action_name | The name of an action in the group.
  enabled | Whether or not the action is now enabled.

void Gio::ActionGroup::action_removed | ( | const Glib::ustring& | action_name | ) |

Emits the ActionGroup::action-removed signal on action_group.

This function should only be called by ActionGroup implementations.

Since glibmm 2.28:

Parameters:

  action_name | The name of an action in the group.

void Gio::ActionGroup::action_state_changed | ( | const Glib::ustring& | action_name,
|  | const Glib::VariantBase& | state
| ) |  |

Emits the ActionGroup::action-state-changed signal on action_group.

This function should only be called by ActionGroup implementations.

Since glibmm 2.28:

Parameters:

  action_name | The name of an action in the group.
  state | The new state of the named action.

void Gio::ActionGroup::activate_action | ( | const Glib::ustring& | action_name,
|  | const Glib::VariantBase& | parameter
| ) |  |

Activate the named action within action_group.

If the action is expecting a parameter, then the correct type of parameter must be given as . If the action is expecting no parameters then must be `0`. See Glib::action_group_get_parameter_type().

Since glibmm 2.28:

Parameters:

  action_name | The name of the action to activate.
  parameter | Parameters to the activation.

static void Gio::ActionGroup::add_interface | ( | GType | gtype_implementer | ) | `[static]`

void Gio::ActionGroup::change_action_state | ( | const Glib::ustring& | action_name,
|  | const Glib::VariantBase& | value
| ) |  |

Request for the state of the named action within action_group to be changed to value.

The action must be stateful and value must be of the correct type. See Glib::action_group_get_state_type().

This call merely requests a change. The action may refuse to change its state or may change its state to something other than value. See Glib::action_group_get_state_hint().

If the value GVariant is floating, it is consumed.

Since glibmm 2.28:

Parameters:

  action_name | The name of the action to request the change on.
  value | The new state.

bool Gio::ActionGroup::get_action_enabled | ( | const Glib::ustring& | action_name | ) | const

Checks if the named action within action_group is currently enabled.

An action must be enabled in order to be activated or in order to have its state changed from outside callers.

Since glibmm 2.28:

Parameters:

  action_name | The name of the action to query.

Returns:
  Whether or not the action is currently enabled.

GActionGroup* Gio::ActionGroup::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

const GActionGroup* Gio::ActionGroup::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

bool Gio::ActionGroup::has_action | ( | const Glib::ustring& | action_name | ) | const

Checks if the named action exists within action_group.

Since glibmm 2.28:

Parameters:

  action_name | The name of the action to check for.

Returns:
  Whether the named action exists.

std::vector<Glib::ustring> Gio::ActionGroup::list_actions | ( |  | ) | const

Lists the actions contained within action_group.

The caller is responsible for freeing the list with Glib::strfreev() when it is no longer required.

Since glibmm 2.28:

Returns:
  A `0`-terminated array of the names of the actions in the groupb.

virtual void Gio::ActionGroup::on_action_added | ( | const Glib::ustring& | action_name | ) | `[protected, virtual]`

virtual void Gio::ActionGroup::on_action_enabled_changed | ( | const Glib::ustring& | action_name,
|  | bool | enabled
| ) |  | `[protected, virtual]`

virtual void Gio::ActionGroup::on_action_removed | ( | const Glib::ustring& | action_name | ) | `[protected, virtual]`

virtual void Gio::ActionGroup::on_action_state_changed | ( | const Glib::ustring& | action_name,
|  | const Glib::VariantBase& | value
| ) |  | `[protected, virtual]`

Glib::SignalProxy1< void,const Glib::ustring& > Gio::ActionGroup::signal_action_added | ( |  | ) |

Prototype:
  `void on_my_action_added(const Glib::ustring& action_name)`

Glib::SignalProxy2< void,const Glib::ustring&,bool > Gio::ActionGroup::signal_action_enabled_changed | ( |  | ) |

Prototype:
  `void on_my_action_enabled_changed(const Glib::ustring& action_name, bool enabled)`

Glib::SignalProxy1< void,const Glib::ustring& > Gio::ActionGroup::signal_action_removed | ( |  | ) |

Prototype:
  `void on_my_action_removed(const Glib::ustring& action_name)`

Glib::SignalProxy2< void,const Glib::ustring&,const Glib::VariantBase& > Gio::ActionGroup::signal_action_state_changed | ( |  | ) |

Prototype:
  `void on_my_action_state_changed(const Glib::ustring& action_name, const Glib::VariantBase& value)`

## Friends And Related Function Documentation

Glib::RefPtr< Gio::ActionGroup > wrap | ( | GActionGroup * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.